#ifndef __REALMCHARACTERGROUPPOSITIONER_H
	#define __REALMCHARACTERGROUPPOSITIONER_H

#include "SceneMoveAnimator.h"
#include "RealmObjectPositioner.h"

class RealmZoomAnimator;
class RealmCharacterObjectPositioner;

enum ZoomState {
	AT_REALM,
	AT_REGION,
	AT_ZONE,
	AT_SCENE,
	INTO_REGION,
	INTO_ZONE,
	INTO_SCENE_PHASE1,
	INTO_SCENE_PHASE2,
	OUT_SCENE_PHASE1,
	OUT_SCENE_PHASE2,
	OUT_ZONE,
	OUT_REGION
};


class RealmCharacterGroupPositioner: public RealmObjectPositioner {

	SceneMoveAnimator RealmWorldAnimator, RegionAnimator, ZoneAnimator, SceneAnimator;

	RealmZoomAnimator *SceneZoomAnimator, *ZoneZoomAnimator, *RegionZoomAnimator;

	ZoomState ZoomMode;
	XYLocation SourceScreenLocation, TargetScreenLocation;

	RealmCharacterObjectPositioner* CharacterPositioner[7];

	RealmZoomAnimator* getZoomAnimator();

public:

	RealmCharacterGroupPositioner(
									RealmSceneView* scene_view, HexSpiralCoordinate start_scene_coordinate,
									RealmSceneView* zone_view, HexSpiralCoordinate start_zone_coordinate,
									RealmSceneView* region_view, HexSpiralCoordinate start_region_coordinate,
									RealmSceneView* realm_world_view, HexSpiralCoordinate start_realm_coordinate
								);
	virtual ~RealmCharacterGroupPositioner();

	RealmCharacterObjectPositioner* getCharacterPositioner(int i) { return CharacterPositioner[i]; }
	ZoomState getZoomState() { return ZoomMode; }

	void setScenePosition(HexSpiralCoordinate c);
	void setZonePosition(HexSpiralCoordinate c);
	void setRegionPosition(HexSpiralCoordinate c);


	double getZoomProgress();

	void startTransition(ZoomState new_mode);

	void update();

	double getScaleFactor();
	XYLocation getScreenLocation();
};


#endif // __REALMCHARACTERGROUPPOSITIONER_H
