
#ifndef __REALMELEVATIONTRIANGLE_H
	#define __REALMELEVATIONTRIANGLE_H

class RealmElevationTriangle;

class RealmSceneElevationSubMap;

#include "RealmNumberGenerator.h"

class RealmElevationTriangleSide {
	private:
		RealmElevationTriangle* ParentTriangle;
		char PositionInTriangle;

		int centerValue;

	public:
		RealmElevationTriangleSide();

		// sets up the mapping variables (pointing to realm location spiral indexes)
		// based on the position of the side within the triangle, and the triangle within the map
		void init(RealmElevationTriangle* parent, char triangle_pos);

		void setCenterValue(int val) { centerValue = val; }
		int getCenterValue() { return centerValue; }

		RealmElevationTriangle* getParentTriangle() { return ParentTriangle; }

		char getTrianglePosition() { return PositionInTriangle; }

		int setSpace(int layer, int idx, int val, bool propagate_neighbors = true);

		int getSpace(int layer, int idx);
};

class RealmElevationTriangle {
	private:
		RealmElevationTriangleSide TriangleSide[3];

		RealmElevationTriangleSide* NeighborSide[3];

		RealmSceneElevationSubMap* ParentSceneMap;
		char PositionInParentMap;

		RealmNumberGenerator* NumGenerator;

		int centerValue;

		int CurrentPhase;

		void populatePhase(int phase);

		int getMapIndexFromTrianglePosition(char sidepos, int  layer, int index);

	public:
		RealmElevationTriangle();

		void setNeighborSides(RealmElevationTriangleSide* neighborside1, RealmElevationTriangleSide* neighborside2, RealmElevationTriangleSide* neighborside3);

		int getCenterValue() { return centerValue; }

		RealmElevationTriangleSide* getTriangleSide(int index) { return &TriangleSide[index]; }
		RealmElevationTriangleSide* getNeighborSide(int index) { return NeighborSide[index]; }

		void init(RealmSceneElevationSubMap* parentmap, char pos, RealmNumberGenerator* num_generator);

		void populate();

		void populateToPhase(int phase);

		int setTriangleMapSpace(char sidepos, int layer, int index, int val);
		int getTriangleMapSpace(char sidepos, int layer, int index);
};

#endif // __REALMELEVATIONTRIANGLE_H
