#ifndef __REALMMAPDISPLAY_H
	#define __REALMMAPDISPLAY_H

#include "RealmSceneKey.h"
#include <map>

class SDL_Renderer;
class RealmView;
class RealmSceneView;
class RealmSceneElevationMapRepository;
class RealmSceneElevationMap;
class HexGridDisplay;
class RealmColorMap;
class RealmSceneBackground;
class RealmBackgroundScroller;
class RealmSceneBackgroundRepository;

class RealmMapDisplay {
private:
	RealmSceneKey SceneCenter;

	RealmView* MasterView;
	RealmSceneView* SceneView;
	RealmSceneElevationMapRepository* MapRepository;
	RealmSceneBackgroundRepository* BackgroundRepository;

	RealmBackgroundScroller* BackgroundScroller;

	RealmSceneElevationMap* CurrentMap;

	bool Active;

public:
	RealmMapDisplay(
					RealmSceneView* scene_view,
					RealmView* master_view,
					RealmSceneElevationMapRepository* maprepo,
					int base_radius,
					int grid_size, bool inverted, int maps_radius,
					RealmSceneKey scene_center
				);

	~RealmMapDisplay();

	void updateSceneCenter();

	double getZoomFactor();

	void activate();
	void toggle();
	void disable();

	void populateStep();
	void populateToStep(int level);
	void populateNeighborStep();
	void populateNeighbors();

	void updateBaseRadius(int base_radius);

	void reCenterCurrentMap();
	void refreshCurrentMap();

	void update();

	void draw(SDL_Renderer* renderer);

	RealmSceneBackground* getSceneBackground(long int idx);

	void updateTextures(SDL_Renderer* renderer);
};

#endif // __REALMMAPDISPLAY_H
