#include "RealmObjectType.h"

void RealmObjectType::init(const std::string& filename) {
	std::string dir = "./svg/";

	graphic.load(dir + filename);
}

void RealmObjectType::drawAt(SDL_Renderer* renderer, XYLocation centerspot, int w, int h) {

	RectSize rect(w, h);
	std::map <RectSize, SDL_Texture*>::iterator it;
	it = textures.find(rect);

	SDL_Texture* texture;

	if (it != textures.end()) {
		texture = it->second;
	} else {
		texture = graphic.renderToTexture(renderer, w, h);
		textures.insert(std::pair<RectSize, SDL_Texture*>(rect, texture));
	}

	graphic.drawTexture(renderer, texture, centerspot);

}

void RealmObjectType::cleanup() {
	for (const auto &entry: textures) {
		graphic.cleanupTexture(entry.second);
	}
}
