#ifndef __REALMZOOMANIMATOR_H
	#define __REALMZOOMANIMATOR_H

#include <functional>

class RealmZoomAnimator {

	private:
		/* both of are specified relative to the this scene's base zoom level */
		double CurrentZoom;
		int ZoomTarget;
		int LastZoomLevel;
		// int ZoomProgress; // between 0 and 10  (10 = 100%) -- for populating map while zooming
		double ZoomProgress;  // new way


		bool AnimatingZoom;

		int ZoomSpeed, MaxZoomSpeed;

		std::function<void()> zoomFinishEvent;
		std::function<void(int)> zoomStepEvent;

		double getZoomScaleAtZoom(int level, double zoom);

	public:

		RealmZoomAnimator(int starting_zoom);

		double getZoomScale(int level);
		double getZoomScaleAtTarget(int level);

		double getZoomProgress();

		void setZoomFinishEvent(std::function<void()> e) { zoomFinishEvent = e; }
		void setZoomStepEvent(std::function<void(int)> e) { zoomStepEvent = e; }

		void startZoom(int target, int max_movement_speed = 12);

		double getCurrentZoom() { return CurrentZoom; }
		int getZoomTarget() { return ZoomTarget; }

		void update(int base_radius);
};

#endif // __REALMZOOMANIMATOR_H
