#include "SceneCameraPositioner.h"
#include "SceneMoveAnimator.h"

SceneCameraPositioner::SceneCameraPositioner() {
	XYAnimator CrossObjectAnimator;

	LastAnimator = TargetAnimator = nullptr;

	IsBetweenAnimators = false;

	CurrentObjectIndex = 0;
}

void SceneCameraPositioner::addObjectAnimator(SceneMoveAnimator* object_animator) {
	ObjectAnimators.push_back(object_animator);
	if (LastAnimator == nullptr)
		LastAnimator = object_animator;
	if (TargetAnimator == nullptr)
		TargetAnimator = object_animator;
}

void SceneCameraPositioner::cycleObjectAnimator() {
		int last_object_index = CurrentObjectIndex;
		if (CurrentObjectIndex < ObjectAnimators.size() - 1)
			CurrentObjectIndex++;
		else
			CurrentObjectIndex = 0;
		if (!IsBetweenAnimators) {
			LastAnimator = ObjectAnimators[last_object_index];
			CrossObjectAnimator.setPosition(LastAnimator->getScreenLocation());
		} else {
			TraversedOffset = TraversedOffset + CrossObjectAnimator.getOffset();
			CrossObjectAnimator.resetPosition();
		}
		TargetAnimator = ObjectAnimators[CurrentObjectIndex];
		CrossObjectAnimator.doMove(TargetAnimator->getScreenLocation() + TraversedOffset);
		IsBetweenAnimators = true;
}

HexSpiralCoordinate SceneCameraPositioner::getHexPosition() {
	return LastAnimator->getHexPosition();
}
XYLocation SceneCameraPositioner::getCurrentOffset() {
	if (IsBetweenAnimators) {
		return CrossObjectAnimator.getOffset() + TraversedOffset;
	} else {
		return LastAnimator->getCurrentOffset();
	}
}

XYLocation SceneCameraPositioner::getScreenLocation() {
	if (IsBetweenAnimators) {
		return CrossObjectAnimator.getPosition();
	} else {
		return ObjectAnimators[CurrentObjectIndex]->getScreenLocation();
	}
}

void SceneCameraPositioner::update() {
	if (IsBetweenAnimators) {
		if (CrossObjectAnimator.advanceFrame()) {
			// reached destination animator
			IsBetweenAnimators = false;
			LastAnimator = TargetAnimator;
			TraversedOffset.setxy(0,0);
		}
	}
}
