
#ifndef __SCENEHEXOUTLINE_H
	#define __SCENEHEXOUTLINE_H

#include "RGBColor.h"

class HexGridDisplay;
class RealmSceneView;
class SDL_Renderer;
class RealmColorMap;

class SceneHexOutline {
	private:
		HexGridDisplay *BaseGrid;
		HexGridDisplay *OverlayGrid1;
		HexGridDisplay *OverlayGrid2;
		HexGridDisplay *OverlayGrid3;

		bool inverted;

	public:
		SceneHexOutline(RGBColor base_line_color, bool invert = false, int base_grid_size = 13);
		~SceneHexOutline();

		void activateOverlay1(RGBColor line_color, bool invert_from_base = true);
		void activateOverlay2(RGBColor line_color, bool invert_from_base = false);
		void activateOverlay3(RGBColor line_color, bool invert_from_base = true);

		void attachBaseColorMap(RealmColorMap* colormap);
		void disableBaseColorMap();

		void update(RealmSceneView* rsv);
		void draw(SDL_Renderer* renderer);
};

#endif // __SCENEHEXOUTLINE_H
